Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 2231)
+++ /palm/trunk/SOURCE/pres.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments to new topography and surface concept
 ! 
 ! Former revisions:
@@ -156,7 +156,6 @@
     USE indices,                                                               &
         ONLY:  nbgp, ngp_2dh_outer, nx, nxl, nxlg, nxl_mg, nxr, nxrg, nxr_mg,  &
-               ny, nys, nysg, nys_mg, nyn, nyng, nyn_mg, nzb, nzb_s_inner,     &
-               nzb_u_inner, nzb_v_inner, nzb_w_inner, nzt, nzt_mg,             &
-               rflags_s_inner
+               ny, nys, nysg, nys_mg, nyn, nyng, nyn_mg, nzb, nzt, nzt_mg,     &
+               wall_flags_0
 
     USE kinds
@@ -176,4 +175,7 @@
                weight_substep
 
+    USE surface_mod,                                                           &
+        ONLY :  bc_h
+
     IMPLICIT NONE
 
@@ -181,4 +183,5 @@
     INTEGER(iwp) ::  j              !<
     INTEGER(iwp) ::  k              !<
+    INTEGER(iwp) ::  m              !<
 
     REAL(wp)     ::  ddt_3d         !<
@@ -269,6 +272,9 @@
 !
 !--       Sum up the volume flow through the south/north boundary
-          DO  k = nzb_u_inner(j,i)+1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + u(k,j,i) * dzw(k)
+          DO  k = nzb+1, nzt
+             volume_flow_l(1) = volume_flow_l(1) + u(k,j,i) * dzw(k)           &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 1 )  &
+                                            )
           ENDDO
        ENDDO
@@ -285,6 +291,9 @@
 
        DO  j = nysg, nyng
-          DO  k = nzb_u_inner(j,i)+1, nzt
-             u(k,j,i) = u(k,j,i) + volume_flow_offset(1)
+          DO  k = nzb+1, nzt
+             u(k,j,i) = u(k,j,i) + volume_flow_offset(1)                       &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 1 )  &
+                                            )
           ENDDO
        ENDDO
@@ -308,6 +317,9 @@
 !
 !--       Sum up the volume flow through the south/north boundary
-          DO  k = nzb_v_inner(j,i)+1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzw(k)
+          DO  k = nzb+1, nzt
+             volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzw(k)           &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 2 )  &
+                                            )
           ENDDO
        ENDDO
@@ -324,6 +336,9 @@
 
        DO  i = nxlg, nxrg
-          DO  k = nzb_v_inner(j,i)+1, nzt
-             v(k,j,i) = v(k,j,i) + volume_flow_offset(2)
+          DO  k = nzb+1, nzt
+             v(k,j,i) = v(k,j,i) + volume_flow_offset(2)                       &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 2 )  &
+                                            )
           ENDDO
        ENDDO
@@ -350,6 +365,9 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_w_inner(j,i)+1, nzt
-                w_l_l(k) = w_l_l(k) + w(k,j,i)
+             DO  k = nzb+1, nzt
+                w_l_l(k) = w_l_l(k) + w(k,j,i)                                 &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 3 )  &
+                                            )
              ENDDO
           ENDDO
@@ -367,6 +385,9 @@
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
-             DO  k = nzb_w_inner(j,i)+1, nzt
-                w(k,j,i) = w(k,j,i) - w_l(k)
+             DO  k = nzb+1, nzt
+                w(k,j,i) = w(k,j,i) - w_l(k)                                   &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 3 )  &
+                                            )
              ENDDO
           ENDDO
@@ -379,5 +400,5 @@
 
     IF ( psolver(1:9) == 'multigrid' )  THEN
-       !$OMP PARALLEL DO SCHEDULE( STATIC )
+       !$OMP PARALLEL DO SCHEDULE( STATIC ) PRIVATE (i,j,k)
        DO  i = nxl-1, nxr+1
           DO  j = nys-1, nyn+1
@@ -388,5 +409,5 @@
        ENDDO
     ELSE
-       !$OMP PARALLEL DO SCHEDULE( STATIC )
+       !$OMP PARALLEL DO SCHEDULE( STATIC ) PRIVATE (i,j,k)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -406,15 +427,21 @@
     DO  i = nxl, nxr
        DO  j = nys, nyn
-          DO  k = nzb_s_inner(j,i)+1, nzt
+          DO  k = nzb+1, nzt
              d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +       &
                           ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +       &
                           ( w(k,j,i)   * rho_air_zw(k) -                       &
                             w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)           &
-                        ) * ddt_3d * d_weight_pres 
+                        ) * ddt_3d * d_weight_pres                             &
+                                   * MERGE( 1.0_wp, 0.0_wp,                    &
+                                            BTEST( wall_flags_0(k,j,i), 0 )    &
+                                          )
           ENDDO
 !
 !--       Compute possible PE-sum of divergences for flow_statistics
-          DO  k = nzb_s_inner(j,i)+1, nzt
-             threadsum = threadsum + ABS( d(k,j,i) )
+          DO  k = nzb+1, nzt
+             threadsum = threadsum + ABS( d(k,j,i) )                           &
+                                   * MERGE( 1.0_wp, 0.0_wp,                    &
+                                            BTEST( wall_flags_0(k,j,i), 0 )    &
+                                          )
           ENDDO
 
@@ -438,5 +465,8 @@
                           ( w(k,j,i)   * rho_air_zw(k) -                       &
                             w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)           &
-                        ) * ddt_3d * d_weight_pres * rflags_s_inner(k,j,i)
+                        ) * ddt_3d * d_weight_pres                             &
+                                   * MERGE( 1.0_wp, 0.0_wp,                    &
+                                            BTEST( wall_flags_0(k,j,i), 0 )    &
+                                          )     
           ENDDO
        ENDDO
@@ -484,5 +514,5 @@
 !--    Store computed perturbation pressure and set boundary condition in
 !--    z-direction
-       !$OMP PARALLEL DO
+       !$OMP PARALLEL DO PRIVATE (i,j,k)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -499,20 +529,44 @@
        IF ( ibc_p_b == 1 )  THEN
 !
-!--       Neumann (dp/dz = 0)
-          !$OMP PARALLEL DO
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                tend(nzb_s_inner(j,i),j,i) = tend(nzb_s_inner(j,i)+1,j,i)
-             ENDDO
+!--       Neumann (dp/dz = 0). Using surfae data type, first for non-natural 
+!--       surfaces, then for natural and urban surfaces
+!--       Upward facing
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(0)%ns
+             i             = bc_h(0)%i(m)            
+             j             = bc_h(0)%j(m)
+             k             = bc_h(0)%k(m)
+             tend(k-1,j,i) = tend(k,j,i)
+          ENDDO
+!
+!--       Downward facing
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(1)%ns
+             i             = bc_h(1)%i(m)            
+             j             = bc_h(1)%j(m)
+             k             = bc_h(1)%k(m)
+             tend(k+1,j,i) = tend(k,j,i)
           ENDDO
 
        ELSE
 !
-!--       Dirichlet
-          !$OMP PARALLEL DO
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                tend(nzb_s_inner(j,i),j,i) = 0.0_wp
-             ENDDO
+!--       Dirichlet. Using surface data type, first for non-natural 
+!--       surfaces, then for natural and urban surfaces
+!--       Upward facing
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(0)%ns
+             i             = bc_h(0)%i(m)            
+             j             = bc_h(0)%j(m)
+             k             = bc_h(0)%k(m)
+             tend(k-1,j,i) = 0.0_wp
+          ENDDO
+!
+!--       Downward facing
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(1)%ns
+             i             = bc_h(1)%i(m)            
+             j             = bc_h(1)%j(m)
+             k             = bc_h(1)%k(m)
+             tend(k+1,j,i) = 0.0_wp
           ENDDO
 
@@ -524,5 +578,5 @@
 !
 !--       Neumann
-          !$OMP PARALLEL DO
+          !$OMP PARALLEL DO PRIVATE (i,j,k)
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -534,5 +588,5 @@
 !
 !--       Dirichlet
-          !$OMP PARALLEL DO
+          !$OMP PARALLEL DO PRIVATE (i,j,k)
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -646,26 +700,29 @@
        DO  j = nys, nyn
 
-          DO  k = 1, nzt
-             IF ( k > nzb_w_inner(j,i) )  THEN
-                w(k,j,i) = w(k,j,i) - dt_3d *                                 &
-                           ( tend(k+1,j,i) - tend(k,j,i) ) * ddzu(k+1) *      &
-                           weight_pres_l
-             ENDIF
-          ENDDO
-
-          DO  k = 1, nzt
-             IF ( k > nzb_u_inner(j,i) )  THEN
-                u(k,j,i) = u(k,j,i) - dt_3d *                                 &
-                           ( tend(k,j,i) - tend(k,j,i-1) ) * ddx *            &
-                           weight_pres_l
-             ENDIF
-          ENDDO
-
-          DO  k = 1, nzt
-             IF ( k > nzb_v_inner(j,i) )  THEN
-                v(k,j,i) = v(k,j,i) - dt_3d *                                 &
-                           ( tend(k,j,i) - tend(k,j-1,i) ) * ddy *            &
-                           weight_pres_l
-             ENDIF
+          DO  k = nzb+1, nzt
+             w(k,j,i) = w(k,j,i) - dt_3d *                                     &
+                           ( tend(k+1,j,i) - tend(k,j,i) ) * ddzu(k+1)         &
+                                     * weight_pres_l                           &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 3 )  &
+                                            )
+          ENDDO
+
+          DO  k = nzb+1, nzt
+             u(k,j,i) = u(k,j,i) - dt_3d *                                     &
+                           ( tend(k,j,i) - tend(k,j,i-1) ) * ddx               &
+                                     * weight_pres_l                           &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 1 )  &
+                                            )
+          ENDDO
+
+          DO  k = nzb+1, nzt
+             v(k,j,i) = v(k,j,i) - dt_3d *                                     &
+                           ( tend(k,j,i) - tend(k,j-1,i) ) * ddy               &
+                                     * weight_pres_l                           &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 2 )  &
+                                            )
           ENDDO                                                         
 
@@ -676,5 +733,5 @@
 !
 !-- Sum up the volume flow through the right and north boundary
-    IF ( conserve_volume_flow  .AND.  bc_lr_cyc  .AND.  bc_ns_cyc  .AND.  &
+    IF ( conserve_volume_flow  .AND.  bc_lr_cyc  .AND.  bc_ns_cyc  .AND.       &
          nxr == nx )  THEN
 
@@ -683,6 +740,9 @@
        DO  j = nys, nyn
           !$OMP CRITICAL
-          DO  k = nzb_u_inner(j,nx) + 1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + u(k,j,nx) * dzw(k)
+          DO  k = nzb+1, nzt
+             volume_flow_l(1) = volume_flow_l(1) + u(k,j,nxr) * dzw(k)         &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,nxr), 1 )&
+                                            )
           ENDDO
           !$OMP END CRITICAL
@@ -692,5 +752,5 @@
     ENDIF
 
-    IF ( conserve_volume_flow  .AND.  bc_ns_cyc  .AND.  bc_lr_cyc  .AND.  &
+    IF ( conserve_volume_flow  .AND.  bc_ns_cyc  .AND.  bc_lr_cyc  .AND.       &
          nyn == ny )  THEN
 
@@ -699,6 +759,9 @@
        DO  i = nxl, nxr
           !$OMP CRITICAL
-          DO  k = nzb_v_inner(ny,i) + 1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + v(k,ny,i) * dzw(k)
+          DO  k = nzb+1, nzt
+             volume_flow_l(2) = volume_flow_l(2) + v(k,nyn,i) * dzw(k)         &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,nyn,i), 2 )&
+                                            )
            ENDDO
           !$OMP END CRITICAL
@@ -727,9 +790,15 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_u_inner(j,i) + 1, nzt
-                u(k,j,i) = u(k,j,i) + volume_flow_offset(1)
-             ENDDO
-             DO  k = nzb_v_inner(j,i) + 1, nzt
-                v(k,j,i) = v(k,j,i) + volume_flow_offset(2)
+             DO  k = nzb+1, nzt
+                u(k,j,i) = u(k,j,i) + volume_flow_offset(1)                    &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 1 )  &
+                                            )
+             ENDDO
+             DO  k = nzb+1, nzt
+                v(k,j,i) = v(k,j,i) + volume_flow_offset(2)                    &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 2 )  &
+                                            )
              ENDDO
           ENDDO
@@ -768,9 +837,12 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-             d(k,j,i) = ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +         &
-                        ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +         &
-                        ( w(k,j,i)   * rho_air_zw(k) -                         &
-                          w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)
+             DO  k = nzb+1, nzt
+             d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +       &
+                          ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +       &
+                          ( w(k,j,i)   * rho_air_zw(k) -                       &
+                            w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)           &
+                        ) * MERGE( 1.0_wp, 0.0_wp,                             &
+                                   BTEST( wall_flags_0(k,j,i), 0 )             &
+                                 )
              ENDDO
              DO  k = nzb+1, nzt
@@ -783,10 +855,12 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = 1, nzt
+             DO  k = nzb+1, nzt
                 d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +    &
                              ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +    &
                              ( w(k,j,i)   * rho_air_zw(k) -                    &
                                w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)        &
-                           ) * rflags_s_inner(k,j,i)
+                           ) * MERGE( 1.0_wp, 0.0_wp,                          &
+                                   BTEST( wall_flags_0(k,j,i), 0 )             &
+                                    )
              ENDDO
           ENDDO
Index: /palm/trunk/SOURCE/production_e.f90
===================================================================
--- /palm/trunk/SOURCE/production_e.f90	(revision 2231)
+++ /palm/trunk/SOURCE/production_e.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new surface concept
 !
 ! Former revisions:
@@ -106,8 +106,4 @@
 !------------------------------------------------------------------------------!
  MODULE production_e_mod
- 
-
-    USE wall_fluxes_mod,                                                       &
-        ONLY:  wall_fluxes_e
 
     USE kinds
@@ -115,9 +111,4 @@
     PRIVATE
     PUBLIC production_e, production_e_init
-
-    LOGICAL, SAVE ::  first_call = .TRUE.  !<
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, SAVE ::  u_0  !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, SAVE ::  v_0  !<
 
     INTERFACE production_e
@@ -141,6 +132,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzw, dd2zu, kh, km, prho, pt, q, ql, qsws, qswst, shf,      &
-                  tend, tswst, u, v, vpt, w
+           ONLY:  ddzw, dd2zu, kh, km, prho, pt, q, ql, tend, u, v, vpt, w
 
        USE cloud_parameters,                                                   &
@@ -154,88 +144,79 @@
 
        USE grid_variables,                                                     &
-           ONLY:  ddx, dx, ddy, dy, wall_e_x, wall_e_y
+           ONLY:  ddx, dx, ddy, dy
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_diff_s_inner,                   &
-                   nzb_diff_s_outer, nzb_s_inner, nzt, nzt_diff
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzt, wall_flags_0
+
+       USE surface_mod,                                                        &
+           ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, &
+                   surf_usm_v
 
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i           !<
-       INTEGER(iwp) ::  j           !<
-       INTEGER(iwp) ::  k           !<
-
-       REAL(wp)     ::  def         !<
-       REAL(wp)     ::  dudx        !<
-       REAL(wp)     ::  dudy        !<
-       REAL(wp)     ::  dudz        !<
-       REAL(wp)     ::  dvdx        !<
-       REAL(wp)     ::  dvdy        !<
-       REAL(wp)     ::  dvdz        !<
-       REAL(wp)     ::  dwdx        !<
-       REAL(wp)     ::  dwdy        !<
-       REAL(wp)     ::  dwdz        !<
+       INTEGER(iwp) ::  i       !< running index x-direction
+       INTEGER(iwp) ::  j       !< running index y-direction
+       INTEGER(iwp) ::  k       !< running index z-direction
+       INTEGER(iwp) ::  l       !< running index for different surface type orientation
+       INTEGER(iwp) ::  m       !< running index surface elements
+       INTEGER(iwp) ::  surf_e  !< end index of surface elements at given i-j position
+       INTEGER(iwp) ::  surf_s  !< start index of surface elements at given i-j position
+
+       REAL(wp)     ::  def         !< 
+       REAL(wp)     ::  flag        !< flag to mask topography
        REAL(wp)     ::  k1          !<
        REAL(wp)     ::  k2          !<
-       REAL(wp)     ::  km_neutral  !<
+       REAL(wp)     ::  km_neutral  !< diffusion coefficient assuming neutral conditions - used to compute shear production at surfaces
        REAL(wp)     ::  theta       !<
        REAL(wp)     ::  temp        !<
-
-!       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  usvs, vsus, wsus, wsvs
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  usvs  !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  vsus  !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsus  !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsvs  !<
-
-!
-!--    First calculate horizontal momentum flux u'v', w'v', v'u', w'u' at
-!--    vertical walls, if neccessary
-!--    So far, results are slightly different from the ij-Version.
-!--    Therefore, ij-Version is called further below within the ij-loops.
-!       IF ( topography /= 'flat' )  THEN
-!          CALL wall_fluxes_e( usvs, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, wall_e_y )
-!          CALL wall_fluxes_e( wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, wall_e_y )
-!          CALL wall_fluxes_e( vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, wall_e_x )
-!          CALL wall_fluxes_e( wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, wall_e_x )
-!       ENDIF
-
+       REAL(wp)     ::  sign_dir    !< sign of wall-tke flux, depending on wall orientation 
+       REAL(wp)     ::  usvs        !< momentum flux u"v"
+       REAL(wp)     ::  vsus        !< momentum flux v"u"
+       REAL(wp)     ::  wsus        !< momentum flux w"u"
+       REAL(wp)     ::  wsvs        !< momentum flux w"v"
+
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dudx  !< Gradient of u-component in x-direction
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dudy  !< Gradient of u-component in y-direction
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dudz  !< Gradient of u-component in z-direction
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dvdx  !< Gradient of v-component in x-direction
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dvdy  !< Gradient of v-component in y-direction
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dvdz  !< Gradient of v-component in z-direction
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dwdx  !< Gradient of w-component in x-direction
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dwdy  !< Gradient of w-component in y-direction
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dwdz  !< Gradient of w-component in z-direction
 
        DO  i = nxl, nxr
 
-!
-!--       Calculate TKE production by shear
-          DO  j = nys, nyn
-             DO  k = nzb_diff_s_outer(j,i), nzt
-
-                dudx  =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
-                dudy  = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) - &
-                                    u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
-                dudz  = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) - &
-                                    u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
-
-                dvdx  = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) - &
-                                    v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
-                dvdy  =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
-                dvdz  = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) - &
-                                    v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
-
-                dwdx  = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) - &
-                                    w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
-                dwdy  = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) - &
-                                    w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
-                dwdz  =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
-
-                def = 2.0_wp * ( dudx**2 + dvdy**2 + dwdz**2 ) +           &
-                      dudy**2 + dvdx**2 + dwdx**2 + dwdy**2 + dudz**2 + &
-                      dvdz**2 + 2.0_wp * ( dvdx*dudy + dwdx*dudz + dwdy*dvdz )
-
-                IF ( def < 0.0_wp )  def = 0.0_wp
-
-                tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def
-
+          IF ( constant_flux_layer )  THEN
+
+!
+!--          Calculate TKE production by shear. Calculate gradients at all grid 
+!--          points first, gradients at surface-bounded grid points will be 
+!--          overwritten further below. 
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt
+
+                   dudx(k,j) =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
+                   dudy(k,j) = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) -         &
+                                           u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
+                   dudz(k,j) = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) -         &
+                                           u(k-1,j,i) - u(k-1,j,i+1) ) *       &
+                                                            dd2zu(k)
+   
+                   dvdx(k,j) = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) -         &
+                                           v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
+                   dvdy(k,j) =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
+                   dvdz(k,j) = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) -         &
+                                           v(k-1,j,i) - v(k-1,j+1,i) ) *       &
+                                                            dd2zu(k)
+
+                   dwdx(k,j) = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) -         &
+                                           w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
+                   dwdy(k,j) = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) -         &
+                                           w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
+                   dwdz(k,j) =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
+
+                ENDDO
              ENDDO
-          ENDDO
-
-          IF ( constant_flux_layer )  THEN
 
 !
